package org.test;

import javax.jms.Connection;
import javax.jms.Destination;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;
import javax.jms.Session;

import org.hornetq.api.jms.HornetQJMSConstants;

public class Consumer extends TestBase
{
    private static final int SLEEP_BETWEEN_MESSAGES_MILLIS = 500;

    public static final void main(String[] args)
    {
        try
        {
            new Consumer().run();
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    private void run() throws Exception
    {
        listen(new TestMessageListener());
    }

    private void listen(MessageListener listener) throws Exception
    {
        Connection connection = createConnection();

        try
        {
            Session session = connection.createSession(false,
                    HornetQJMSConstants.PRE_ACKNOWLEDGE);

            final Destination destination = getDestination(connection);

            session.createConsumer(destination).setMessageListener(listener);
            connection.start();
            System.in.read();
        }
        finally
        {
            connection.close();
        }
    }

    // // To connect via servlet
    // protected Map<String, Object> getParams()
    // {
    // final Map<String, Object> params = new HashMap<String, Object>();
    //
    // params.put("use-nio", "true");
    // params.put("use-servlet", "true");
    // params.put("servlet-path", "/hornetq-servlet/HornetQServlet");
    // params.put("ssl-enabled", "true");
    // params.put("key-store-path", "client.jks");
    // params.put("key-store-password", "password");
    //
    // params.put(TransportConstants.HOST_PROP_NAME, HOST_NAME);
    // params.put(TransportConstants.PORT_PROP_NAME, "443");
    //
    // return params;
    // }

    private class TestMessageListener implements MessageListener
    {
        public void onMessage(Message msg)
        {
            if (msg instanceof ObjectMessage)
            {
                try
                {
                    TestObject obj = (TestObject) ((ObjectMessage) msg)
                            .getObject();
                    System.out.println(obj);
                    Thread.sleep(SLEEP_BETWEEN_MESSAGES_MILLIS);
                }
                catch (Exception e)
                {
                    e.printStackTrace();
                }
            }
        }
    }
}
