package org.test;

import javax.jms.Connection;
import javax.jms.DeliveryMode;
import javax.jms.Destination;
import javax.jms.MessageProducer;
import javax.jms.ObjectMessage;
import javax.jms.Session;

public class Producer extends TestBase
{
    private static final int SLEEP_BETWEEN_MESSAGES_MILLIS = 5;

    public static final void main(String[] args)
    {
        try
        {
            new Producer().run();
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    private void run() throws Exception
    {
        Connection connection = createConnection();

        try
        {
            Session session = connection.createSession(false,
                    Session.AUTO_ACKNOWLEDGE);

            final Destination destination = getDestination(connection);

            final MessageProducer producer = session
                    .createProducer(destination);
            producer.setDeliveryMode(DeliveryMode.NON_PERSISTENT);

            while (true)
            {
                TestObject obj = new TestObject();
                ObjectMessage msg = session.createObjectMessage(obj);
                producer.send(msg);
                System.out.println(msg + " : " + obj);
                Thread.sleep(SLEEP_BETWEEN_MESSAGES_MILLIS);
            }
        }
        finally
        {
            connection.close();
        }
    }
}
